/*
*  pa_Potentiometer
*  
*  Reads the values which represent the state of a potentiometer 
*  from the serial port and draws a graphical representation.
* 
*  This file is part of the Arduino meets Processing Project.
*  For more information visit http://www.arduino.cc.
*
*  copyleft 2005 by Melvin Ochsmann for Malm� University
*
*/

int anzahl_rings = 10;
int rings[] = new int[anzahl_rings];
int anzahl_stars = 1000;
int stars_x[] = new int[anzahl_stars];
int stars_y[] = new int[anzahl_stars];
int stars_z[] = new int[anzahl_stars];


// importing the processing serial class
import processing.serial.*;

// definition of window size and framerate
  int xWidth = 768;
  int yHeight = 512;
  
// attributes of the display
  boolean bck = true;
  boolean grid = true;
  boolean g_vert = true;
  boolean g_horiz = false;
  boolean g_values = true;
  boolean output = true;
  
// variables for serial connection, portname and baudrate have to be set 
  Serial port;
  String portname = "COM2";  
  int baudrate = 9600;
  int value = 0; 
  String buf=""; 
  int value1=0;  

// variables to draw graphics
  int xpos; 

void setup(){
  // set size and framerate
  size(xWidth, yHeight); 
  // establish serial port connection      
  port = new Serial(this, portname, baudrate);
  println(port);
}

void drawPotiState(){
   noStroke();
   pushMatrix();
   fill(0, 0, 255);
   translate(xpos,yHeight/10*6);
//   rect(0, 0, 32, 32);
   ellipse(0,0,64,64);
   popMatrix();
}

void drawStars(){
  for(int i = 0; i < anzahl_stars; i++)
  {
    stars_z[i]--;
    if (stars_z[i] < 1) {
      stars_x[i] = int(random(-width*16,width*16));
      stars_y[i] = int(random(-height*16,height*16));
      stars_z[i] = int(random(500,800));
    }
    fill(255);
    ellipse(width/2 + stars_x[i]/(16+stars_z[i]),height/2 + stars_y[i]/(16+stars_z[i]),10/stars_z[i],10/stars_z[i]);
  }
}

void serialEvent(int serial){
  // if serial event is not a line break 
  if(serial!=10) {        
    // add event to buffer
    buf += char(serial);          
    } else {
    // if serial is line break set value1 to buff and clear it
    value1 = int(buf);
    buf="";
    }
    // convert value1 to xpos
    xpos = constrain ( ( ((value1-100)*(width+100))/width )  ,0, width-12); 
    if(output) println("xpos: "+xpos);
}

int z = 20;
int bahn = 0;

// draw listens to serial port, draw 
void draw(){
// listen to serial port and trigger serial event  
  while(port.available() > 0){
        value = port.read();
        serialEvent(value);
    }
    
    fill(0,4);
    noStroke();
    rect(0,0,width,height);
    copy(8, 8, width-15, height-15, 0, 0, width, height);
    //background(0);
    
    stroke(255);
    ellipseMode(CENTER);
    ellipse(width/2 + sin(bahn/40)*100,height/2,1000/z,1000/z);
    z--;
    bahn++;
    if (z < 1) z = 20;
    
    drawPotiState();
    drawStars();
}
